; PPM image writing routine
; BP 200905

(defun set-pixel (img x y r g b)
	(let ((image (eval img)))
		(setf (aref img y x 0) r)
		(setf (aref img y x 1) g)
		(setf (aref img y x 2) b)
		nil
	)
)

(defun new-img (w h)
	(make-array (list w h 3) :initial-element 0)
)

(defun img-to-file (img name)
	(with-open-file (s name :direction :output :if-exists :supersede :element-type 'unsigned-byte)
  	(let ((width (first (array-dimensions img)))(height (second (array-dimensions img))))
			(setq strstrm (make-string-output-stream))
			(format strstrm "P6 ~d ~d 255~%" width height)
			(setq str (get-output-stream-string strstrm))
			(dotimes (i (length str))
				(write-byte (char-code (aref str i)) s)
			)
			(dotimes (i height)
		    (dotimes (j width)
					(let ((r (aref img i j 0)) (g (aref img i j 1)) (b (aref img i j 2)))
						(write-byte r s)
						(write-byte g s)
						(write-byte b s)
					)
				)
			)
		)
	)
)

			
; a test
;(setq newimg (new-img 100 100))
;(dotimes (i 100)
;	(dotimes (j 100)
;		(set-pixel newimg i j i i i)
;	)
;)
;(img-to-file newimg "test.ppm")
